var targetDial = -1;
var gPref = Components.classes["@mozilla.org/preferences-service;1"]
               .getService(Components.interfaces.nsIPrefService)
               .QueryInterface(Components.interfaces.nsIPrefBranch2);

var addDialBundle;

function Startup() {
  // Set variables
  targetDial = window.arguments[0];
  addDialBundle = document.getElementById("bundle_editDial");

  if (gPref.prefHasUserValue("extensions.speeddial.thumbnail-" + targetDial + "-url")) {
    // We've an URL, edit
    document.getElementById("url").value = gPref.getCharPref("extensions.speeddial.thumbnail-" + targetDial + "-url");
    document.getElementById("title").value = gPref.getComplexValue("extensions.speeddial.thumbnail-" + targetDial + "-label", Components.interfaces.nsISupportsString).data;
    if (gPref.prefHasUserValue("extensions.speeddial.thumbnail-" + targetDial + "-dynamictitle")) {
      document.getElementById("dynamicTitle").checked = gPref.getBoolPref("extensions.speeddial.thumbnail-" + targetDial + "-dynamictitle");
    }
    if (gPref.prefHasUserValue("extensions.speeddial.thumbnail-" + targetDial + "-refreshinterval")) {
      document.getElementById("refreshType").selectedIndex = 1;
      document.getElementById("refreshInterval").value = gPref.getIntPref("extensions.speeddial.thumbnail-" + targetDial + "-refreshinterval");
    }
  } else {
    // We don't have an URL, new dial
    // Set title
    document.title = addDialBundle.getString("addDialTitle");
    // Set default thumbnail refresh
    var defaultRefreshInterval = gPref.getIntPref("extensions.speeddial.defaultRefreshInterval");
    if (defaultRefreshInterval > 0) {
      document.getElementById("refreshType").selectedIndex = 1;
      document.getElementById("refreshInterval").value = defaultRefreshInterval;
    }
  }

  dynamicTitleChanged();
  refreshTypeChanged();

  sizeToContent();
}

function onOK(event) {
  var trimmedURL = document.getElementById("url").value.replace(/^\s+|\s+$/g, '') ;
  if (trimmedURL.length == 0) {
    alert(addDialBundle.getString("noURLAlert"));
    return false;
  }

  if (gPref.prefHasUserValue("extensions.speeddial.thumbnail-" + targetDial + "-url")) {
    var isRefreshing = false;

    // Thumbnail URL
    var oldURL = gPref.getCharPref("extensions.speeddial.thumbnail-" + targetDial + "-url");
    if (oldURL != trimmedURL) {
      gPref.setCharPref("extensions.speeddial.thumbnail-" + targetDial + "-url", trimmedURL);
      isRefreshing = true;
      if (gPref.prefHasUserValue("extensions.speeddial.thumbnail-" + targetDial + "-lastsaved")) {
        gPref.clearUserPref("extensions.speeddial.thumbnail-" + targetDial + "-lastsaved");
      }
    }

    // Thumbnail title
    var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
    str.data = document.getElementById("title").value;
    gPref.setComplexValue("extensions.speeddial.thumbnail-" + targetDial + "-label", Components.interfaces.nsISupportsString, str);

    // Dynamic title
    var oldDynamicTitle = false;
    if (gPref.prefHasUserValue("extensions.speeddial.thumbnail-" + targetDial + "-dynamictitle")) {
      oldDynamicTitle = gPref.getBoolPref("extensions.speeddial.thumbnail-" + targetDial + "-dynamictitle");
    }
    var newDynamicTitle = document.getElementById("dynamicTitle").checked;
    if (oldDynamicTitle != newDynamicTitle) {
      gPref.setBoolPref("extensions.speeddial.thumbnail-" + targetDial + "-dynamictitle", newDynamicTitle);
      if (newDynamicTitle && !isRefreshing) {
        // TODO: Ask user if he wants to refresh the thumbnail

        gPref.setBoolPref("extensions.speeddial.thumbnail-" + targetDial + "-manualrefresh", true);
      }
    }
    
    // modify time intervals
    if (document.getElementById("refreshType").selectedIndex == 1) {
      gPref.setIntPref("extensions.speeddial.thumbnail-" + targetDial + "-refreshinterval", document.getElementById("refreshInterval").value);
    } else {
      if (gPref.prefHasUserValue("extensions.speeddial.thumbnail-" + targetDial + "-refreshinterval")) {
        gPref.clearUserPref("extensions.speeddial.thumbnail-" + targetDial + "-refreshinterval");
      }
    }
  } else {
    // Just add the information...
    gPref.setCharPref("extensions.speeddial.thumbnail-" + targetDial + "-url", trimmedURL);

    var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
    str.data = document.getElementById("title").value;
    gPref.setComplexValue("extensions.speeddial.thumbnail-" + targetDial + "-label", Components.interfaces.nsISupportsString, str);

    gPref.setCharPref("extensions.speeddial.thumbnail-" + targetDial + "-icon", "data:");
    gPref.setBoolPref("extensions.speeddial.thumbnail-" + targetDial + "-dynamictitle", document.getElementById("dynamicTitle").checked);

    // add time intervals
    if (document.getElementById("refreshType").selectedIndex == 1) {
      gPref.setIntPref("extensions.speeddial.thumbnail-" + targetDial + "-refreshinterval", document.getElementById("refreshInterval").value);
    } else {
      if (gPref.prefHasUserValue("extensions.speeddial.thumbnail-" + targetDial + "-refreshinterval")) {
        gPref.clearUserPref("extensions.speeddial.thumbnail-" + targetDial + "-refreshinterval");
      }
    }
  }

  return true;
}

function onCancel(event) {
  return true;
}

function dynamicTitleChanged() {
  document.getElementById("title").disabled = document.getElementById("dynamicTitle").checked;
}

function refreshTypeChanged() {
  document.getElementById("refreshIntervalBox").hidden = !(document.getElementById("refreshType").selectedIndex == 1);
}